## Прошивка для USB-дисплея

### Схема модуля
1. DigiSpark
2. MAX7219

### Команды дисплея
* отображение кода в сегменте с точкой - **[ABCDEFGH]код**. Сегменты слева направо ABCDEFGH, код символа из таблицы ниже
* отображение кода в сегменте без точки - **[abcdefgh]код**. Сегменты слева направо abcdefgh, код символа из таблицы ниже
* яркость дисплея - **i[0-9a-f]**. Пример: яркость 9/16 - **i9**
* количество отображаемых разрядов - **l[0-7]**. Пример: отображать 5 рязрядов - **l5**
* очистка дисплея - **x0**
* включение/выключение дисплея - **s[0|1]**
* управление зуммером на P3 - **z[0-9a-f]**. z0 - выключение, остальные сигнал - число\*100Hz

### Таблица доступных символов

| Код | Символ | Дисплей | Код | Символ | Дисплей |
|:---:|:------:|:-------:|:---:|:------:|:-------:|
|2A|\*|°|2D|\-|\-|
|30|0|0|31|1|1|
|32|2|2|33|3|3|
|34|4|4|35|5|5|
|36|6|6|37|7|7|
|38|8|8|39|9|9|
|41|=|=|41|A|A|
|43|C|C|45|E|E|
|46|F|F|47|G|G|
|48|H|H|4A|J|J|
|4C|L|L|4E|N|П|
|50|P|P|55|U|U|
|59|Y|Y|5F|\_|\_|
|61|a|a|62|b|b|
|63|c|c|64|d|d|
|65|e|e|68|h|h|
|69|i|i|6A|j|j|
|6C|l|l|6E|n|n|
|6F|o|o|71|q|q|
|72|r|r|74|t|t|
|75|u|u||||

### Прошивка EEPROM в Digispark

Прошивку делал через ArduinoISP, схема подключения:
![Схема подключения](./maxresdefault.jpg)

Для прошивки использовал [AVRDUDESS – A GUI for AVRDUDE](http://blog.zakkemble.net/avrdudess-a-gui-for-avrdude/). Скрин настроек:
![Скрин настроек](./avrdude.jpg)